
import base_section

from runtest import conditions

class Validation(base_section.BaseSection):

    name = "validation"
    options = [
        'auth_method',
        'connect_method',
        'connect_timeout',
        'floating_ip_range',
        'image_ssh_password',
        'image_ssh_user',
        'ip_version_for_ssh',
        'network_for_ssh',
        'ping_count',
        'ping_size',
        'ping_timeout',
        'run_validation',
        'security_group',
        'security_group_rules',
        'ssh_shell_prologue',
        'ssh_timeout',
    ]


    @property
    def auth_method(self):
        pass

    @property
    def connect_method(self):
        c = conditions.BaseRule(field='keystone.client.enabled', op='eq',
                                val=True)
        nodes = self.get_nodes_where_condition_match(c)

        keystone_profile_admin = self.runtest_opts.get('keystone_profile_admin', {})
        res = self.authenticated_openstack_module_call(
            nodes[0], 'neutronng.list_networks', profile=keystone_profile_admin)[nodes[0]]['networks']
        external_routers = [net['router:external'] for net in res]

        if True in external_routers:
            return 'floating'
        else:
            return 'fixed'

    @property
    def connect_timeout(self):
        pass

    @property
    def floating_ip_range(self):
        pass

    @property
    def image_ssh_password(self):
        image_name = self.runtest_opts.get('convert_to_uuid', {}).get(
            'compute', {}).get('image_ref')
        if not image_name:
            return

        image_map = {'TestCirros-0.3.5': 'cubswin:)', 'TestCirros-0.4.0': 'gocubsgo', 'TestFedora-27-1.6': ''}

        return image_map.get(image_name)

    @property
    def image_ssh_user(self):
        image_name = self.runtest_opts.get('convert_to_uuid', {}).get(
            'compute', {}).get('image_ref')
        if not image_name:
            return

        image_map = {'TestCirros-0.3.5': 'cirros', 'TestCirros-0.4.0': 'cirros', 'TestFedora-27-1.6': 'fedora'}

        return image_map.get(image_name)

    @property
    def ip_version_for_ssh(self):
        pass

    @property
    def network_for_ssh(self):
        pass

    @property
    def ping_count(self):
        pass

    @property
    def ping_size(self):
        pass

    @property
    def ping_timeout(self):
        pass

    @property
    def run_validation(self):
        pass

    @property
    def security_group(self):
        pass

    @property
    def security_group_rules(self):
        pass

    @property
    def ssh_shell_prologue(self):
        pass

    @property
    def ssh_timeout(self):
        pass
